﻿function HTMLActuator() {
  this.tileContainer    = document.querySelector(".tile-container");
  this.scoreContainer   = document.querySelector(".score-container");
  this.bestContainer    = document.querySelector(".best-container");

  this.score = 0;
}

HTMLActuator.prototype.actuate = function (grid, metadata) {
  var self = this;

  window.requestAnimationFrame(function () {
    self.clearContainer(self.tileContainer);

    grid.cells.forEach(function (column) {
      column.forEach(function (cell) {
        if (cell) {
          self.addTile(cell);
        }
      });
    });

    self.updateScore(metadata.score);
    self.updateBestScore(metadata.bestScore);

    if (metadata.terminated) {
      if (metadata.over) {
        self.message(false,metadata.score); // You lose
      } else if (metadata.won) {
        self.message(true,metadata.score); // You win!
      }
    }

  });
};

// Continues the game (both restart and keep playing)
HTMLActuator.prototype.continueGame = function () {
  //this.clearMessage();
};

HTMLActuator.prototype.clearContainer = function (container) {
  while (container.firstChild) {
    container.removeChild(container.firstChild);
  }
};

HTMLActuator.prototype.addTile = function (tile) {
  var text=new Array(18);
  text[0] = " ";
  text[1] = "夏";//2
  text[2] = "商";//4
  text[3] = "周";//8
  text[4] = "秦";//16
  text[5] = "汉";//32
  text[6] = "唐";//64
  text[7] = "宋";//128
  text[8] = "元";//256
  text[9] = "明";//512
  text[10] = "清";//1024
  text[11] = "民国";//2048
  text[12] = "天朝";//4096
  var self = this;
  var text2 = function (n) { var r = 0; while (n > 1) r++, n >>= 1; return r; }

  var wrapper   = document.createElement("div");
  var inner     = document.createElement("div");
  var position  = tile.previousPosition || { x: tile.x, y: tile.y };
  var positionClass = this.positionClass(position);

  // We can't use classlist because it somehow glitches when replacing classes
  var classes = ["tile", "tile-" + tile.value, positionClass];

  if (tile.value > 1024) classes.push("tile-super");

  this.applyClasses(wrapper, classes);

  inner.classList.add("tile-inner");
  inner.innerHTML = text[text2(tile.value)];

  if (tile.previousPosition) {
    // Make sure that the tile gets rendered in the previous position first
    window.requestAnimationFrame(function () {
      classes[2] = self.positionClass({ x: tile.x, y: tile.y });
      self.applyClasses(wrapper, classes); // Update the position
    });
  } else if (tile.mergedFrom) {
    classes.push("tile-merged");
    this.applyClasses(wrapper, classes);

    // Render the tiles that merged
    tile.mergedFrom.forEach(function (merged) {
      self.addTile(merged);
    });
  } else {
    classes.push("tile-new");
    this.applyClasses(wrapper, classes);
  }

  // Add the inner part of the tile to the wrapper
  wrapper.appendChild(inner);

  // Put the tile on the board
  this.tileContainer.appendChild(wrapper);
};

HTMLActuator.prototype.applyClasses = function (element, classes) {
  element.setAttribute("class", classes.join(" "));
};

HTMLActuator.prototype.normalizePosition = function (position) {
  return { x: position.x + 1, y: position.y + 1 };
};

HTMLActuator.prototype.positionClass = function (position) {
  position = this.normalizePosition(position);
  return "tile-position-" + position.x + "-" + position.y;
};

HTMLActuator.prototype.updateScore = function (score) {
  this.clearContainer(this.scoreContainer);

  var difference = score - this.score;
  this.score = score;

  this.scoreContainer.textContent = this.score;

  if (difference > 0) {
    var addition = document.createElement("div");
    addition.classList.add("score-addition");
    addition.textContent = "+" + difference;

    this.scoreContainer.appendChild(addition);
  }
};

HTMLActuator.prototype.updateBestScore = function (bestScore) {
  this.bestContainer.textContent = bestScore;
};

HTMLActuator.prototype.message = function (won,score) {
	update_score(score);
  get_rank();
  var mytxt=new Array(14);
  mytxt[0]="连秦始皇都见不到了T.T";
  mytxt[1]="曹贼你还我大汉江山！";
  mytxt[2]="江山难坐啊！";
  mytxt[3]="安史之乱亡我大唐……";
  mytxt[4]="赵匡胤黄袍加身，兵不血刃啊！";
  mytxt[5]="元人铁蹄果然厉害！";
  mytxt[6]="明朝天下一统，可惜看不到了！";
  mytxt[7]="天地会的弟兄们，反清复明啊！";
  mytxt[8]="连辛亥革命的黎明都没等到……";
  mytxt[9]="看不到天朝的太阳了 = =";


  var text3 = function (m) { var r = 0; while (m > 1) r++, m >>= 1; return r; }
  var type    = won ? "game-won" : "game-over";
  var message = won ? "中华人民共和国万岁！" : mytxt[text3(best_score_in_this_round)-3];

  if ( won ){
  	message = "<p>"+message+"</p>"+score;
  	play_music("win.mp3");
  } else {
  	message= "<p>"+message+"</p>"+score;
  	play_music("fail.mp3");
  }
  
  
 	setTimeout( function(){
	 	$("#cb_1 .win").hide();
 		$("#cb_1 .end h1").html(message);
	 	$("#cb_1 .end").show();
	 	$("#cb_1").show();
 	},2000 );
 	
};

HTMLActuator.prototype.clearMessage = function () {
};

HTMLActuator.prototype.scoreTweetButton = function () {
};
